#!/usr/bin/perl
#=============================================================================
# RNA Auto Ping Reception (XML-RPC)
#=============================================================================
#
# 自動Ping を受け付け，アンテナを更新するスクリプト
#
#=============================================================================
# Copyright (C) 2003           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================

# ライブラリ
use strict;
use lib qw(lib extlib);
use CGI;
use RNA;

my $cgi = new CGI;

#----------------------------------
# 基本設定
#----------------------------------
my $self_uri = $cgi->self_url();

#==============================================================================
# main
#==============================================================================

my $rna = RNA->new(Config => './config.pl');

#-----------------------------------
# レスポンス （XML）
#-----------------------------------
my $res = &response;

#-----------------------------------
# アンテナの更新
#-----------------------------------
$rna->run(Type=>'AutoPing', TransferURI=>'', Response => $res);


#=============================================================================
# サブルーチン
#=============================================================================


# $str = &response;
sub response
{

	my $content = qq(<?xml version="1.0"?>
<methodResponse>
  <params>
    <param>
      <value>
        <struct>
          <member>
            <name>flerror</name>
            <value>
              <boolean>0</boolean>
            </value>
          </member>
          <member>
            <name>message</name>
            <value>Thanks for the ping.</value>
          </member>
        </struct>
      </value>
    </param>
  </params>
</methodResponse>
);

	my $length = length($content);
	#my ($s,$m,$h,$md,$M,$y,$wd,$yd,$isdst) = localtime(time);
	#my $month = ($M + 1);
	#$y += 1900;

#HTTP/1.1 200 OK
#Connection: close
	my $header = qq(Status: 200 OK
Content-Length: $length
Content-Type: text/xml
Server: RNA
);

#Date: Sun, 30 Sep 2001 20:02:30 GMT

	return $header . "\n" . $content;
}
